#include <stdio.h>
#include <stdlib.h>

int MULTIPLEMODELDESC_HASH = 631490897;

typedef struct
{
    long hash;
    long folderNum;
    long fileNum;
    long pazNum;
    long offset;
    long zsize;
    long size;
} FileBlock;

void readBlock(FileBlock* fileBlock, FILE* fp)
{
    fread(&fileBlock->hash,sizeof(long),1,fp);
    fread(&fileBlock->folderNum,sizeof(long),1,fp);
    fread(&fileBlock->fileNum,sizeof(long),1,fp);
    fread(&fileBlock->pazNum,sizeof(long),1,fp);
    fread(&fileBlock->offset,sizeof(long),1,fp);
    fread(&fileBlock->zsize,sizeof(long),1,fp);
    fread(&fileBlock->size,sizeof(long),1,fp);
}

void printBlock(FileBlock* fileBlock)
{
    printf("\nhash: %ld", fileBlock->hash);
    printf(" folder: %ld", fileBlock->folderNum);
    printf(" file: %ld", fileBlock->fileNum);
    printf(" paz_num: %ld", fileBlock->pazNum);
    printf(" offset: %ld", fileBlock->offset);
    printf(" zsize: %ld", fileBlock->zsize);
    printf(" size: %ld", fileBlock->size);
}

int main()
{
    FileBlock fileBlock;
    fileBlock.pazNum = 1;

    FILE* fp = fopen("pad00000.meta","rb");

    if (!fp)
    {
        exit(1);
    }

    int buffer;
    fread(&buffer,sizeof(long),1,fp); // DUMMY
    fread(&buffer,sizeof(long),1,fp); // PAZ_COUNT

    printf("\nPaz Count: %ld", buffer);
    long pazCount = buffer;

    long i = 0;
    for (i = 0; i < pazCount; i++)
    {
        fread(&buffer,sizeof(long),1,fp); //PAZ_NUMBER
        fread(&buffer,sizeof(long),1,fp); // PAZ_HASH
        fread(&buffer,sizeof(long),1,fp); // PAZ_SIZE
    }

    fread(&buffer,sizeof(long),1,fp); // FILE_BLOCKS_COUNT
    printf("\nTotal file blocks: %ld", buffer);
    long fileBlocksCount = buffer;


    // Searches for the hash we know exists
    while (buffer != MULTIPLEMODELDESC_HASH)
    {
        fread(&buffer,sizeof(long),1,fp);
    }

    fseek(fp,-(1 * sizeof(long)),SEEK_CUR); // Goes back to the begining of this block
    readBlock(&fileBlock,fp);

    while(fileBlock.pazNum <= pazCount && fileBlock.pazNum >= 1)
    {
        fseek(fp,-(2*(7 * sizeof(long))),SEEK_CUR); // Goes back one file block
        readBlock(&fileBlock,fp);
    }

    long count = 0;
    fileBlock.pazNum = 1;

    // Byte where the file blocks definitions will start (just to use in blackdesert.bms)
    long OFFSET = ftell(fp);
    printf("\nOFFSET: %ld\n", OFFSET);

    long fileBlocksEndByte = 0;
    // Here we have the pointer to the first hash of the first file block
    while(fileBlock.pazNum <= pazCount && fileBlock.pazNum >= 1)
    {
        readBlock(&fileBlock,fp);
        printBlock(&fileBlock);

        if (fileBlock.pazNum <= pazCount && fileBlock.pazNum >= 1)
        {
            count++;
            fileBlocksEndByte = ftell(fp); // In the end will have the position of the end of the file blocks definition (where the FOLDER_PART_LENGTH should be)
        }
    }

    printf("\nTMP: %ld\nFILES: %ld", fileBlocksEndByte, count);
    printf("\n");

    fclose(fp);
    return 0;
}
